#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

using ll = long long;

const int MAX_N = 100'000;
const int MIN_VAL = 1'000'000'000;
const int MAX_VAL = 1'000'000'000;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    string mode = opt<string>("mode", "rand");
    int n = opt<int>("n", MAX_N);
    int zero_d = opt<bool>("zero_d", false);
    ll min_val = opt<int>("min_val", MIN_VAL);
    ll max_val = opt<int>("max_val", MAX_VAL);
    ll min_val_d = opt<int>("min_val_d", min_val);
    ll max_val_d = opt<int>("max_val_d", max_val);

    vector<ll> d(n), l(n), r(n);
    ll a0, b0;
    if (mode == "rand") {
        if (zero_d) {
            d.assign(n, 0);
        } else {
            for (int i = 0; i < n; ++i) {
                d[i] = rnd.next(min_val_d, max_val_d);
            }
        }
        for (int i = 0; i < n; ++i) {
            l[i] = rnd.next(min_val, max_val);
        }
        for (int i = 0; i < n; ++i) {
            r[i] = rnd.next(min_val, max_val);
        }
        a0 = rnd.next(min_val, max_val);
        b0 = rnd.next(min_val, max_val);
    } else if (mode == "smart") {
        ll sum_d = 0;
        if (zero_d) {
            d.assign(n, 0);
        } else {
            for (int i = 0; i < n; ++i) {
                d[i] = rnd.next(min_val_d, max_val_d);
                sum_d += d[i];
            }
        }

        for (int i = 0; i < n; ++i) {
            l[i] = rnd.next(sum_d, max_val);
            r[i] = rnd.next(sum_d, max_val);
        }
        sort(r.begin(), r.end());
        sort(l.rbegin(), l.rend());
        
        string shuffle_mode = opt<string>("shuffle", "no");
        
        if (shuffle_mode == "simple") {
            shuffle(l.begin(), l.end());
            shuffle(r.begin(), r.end());
        } else if (shuffle_mode == "pairs") {
            vector<int> perm(n);
            iota(perm.begin(), perm.end(), 0);
            shuffle(perm.begin(), perm.end());
            vector<ll> l_(n), r_(n);
            for (int i = 0; i < n; ++i) {
                l_[i] = l[perm[i]];
                r_[i] = r[perm[i]];
            }
            l = l_;
            r = r_;
        } else if (shuffle_mode == "close") {
            for (int i = 0; i + 5 < n; i += 4) {
                shuffle(l.begin() + i, l.begin() + i + 5);
                shuffle(r.begin() + i, r.begin() + i + 5);
            }
        }
        
        a0 = rnd.next(*max_element(l.begin(), l.end()), max_val) - sum_d;
        b0 = rnd.next(*max_element(r.begin(), r.end()), max_val) - sum_d;
        
        sum_d = 0;
        for (int i = n - 1; i >= 0; --i) {
            r[i] -= sum_d;
            l[i] -= sum_d;
            sum_d += d[i];
            // l[i] = max(l[i], 0ll);
            // r[i] = max(r[i], 0ll);
        }
        
        if (rnd.next(1)) {
            swap(l, r);
            swap(a0, b0);
        }
    } else if (mode == "oneside") {
        string side = opt<string>("side", "left");
        
        ll sum_d = 0;
        if (zero_d) {
            d.assign(n, 0);
        } else {
            for (int i = 0; i < n; ++i) {
                d[i] = rnd.next(min_val_d, max_val_d);
                sum_d += d[i];
            }
        }
        for (int i = 0; i < n; ++i) {
            l[i] = rnd.next(min_val, max_val);
        }
        for (int i = 0; i < n; ++i) {
            r[i] = rnd.next(min_val, max_val);
        }
        
        sum_d = 0;
        for (int i = n - 1; i >= 0; --i) {
            r[i] -= sum_d;
            l[i] -= sum_d;
            sum_d += d[i];
            
            l[i] = max(0LL, l[i]);
            r[i] = max(0LL, r[i]);
        }
        
        a0 = *max_element(l.begin(), l.end()) + 1;
        b0 = *min_element(r.begin(), r.end());
        
        if (side == "right") {
            swap(l, r);
            swap(a0, b0);
        }
    }
    
    println(n);
    println(d);
    println(l);
    println(r);
    println(a0, b0);
}
